<route lang="yaml">
meta:
  enabled: false
</route>

<script lang="ts" setup>
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { createDbType, getDbTypeById, updateDbType } from '@/api/database/dbTypeApi'
const emit = defineEmits(['success'])

const formRef = ref<FormInstance>()
const formRules = ref<FormRules>({
  dbTypeTitle: [
    { required: true, message: '请输入标题', trigger: 'blur' },
  ],
  dbTypeDesc: [
    { required: false, message: '请输入描述', trigger: 'blur' },
  ],
})

const state = reactive({
  title: '',
  dialogVisible: false,
  loading: false,
  formData: {
    dbTypeId: 0,
    dbTypeTitle: '',
    dbTypeDesc: '',
  },
  actionType: 1,
})

onMounted(() => {})

const getData = async (dbTypeId: number) => {
  state.loading = true
  const { data } = await getDbTypeById(dbTypeId)
  state.loading = false
  state.formData = data
}

function onSubmit() {
  formRef.value && formRef.value.validate(async (valid) => {
    if (valid) {
      if (state.actionType === 1) {
        const { msg } = await createDbType(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
      else {
        const { msg } = await updateDbType(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
    }
  })
}

function onCancel() {
  state.dialogVisible = false
}

function resetFormData() {
  state.formData = {
    dbTypeId: 0,
    dbTypeTitle: '',
    dbTypeDesc: '',
  }
}

defineExpose({
  showAddModel() {
    resetFormData()
    state.title = '新增'
    state.actionType = 1
    state.dialogVisible = true
  },
  showEditModel(dbTypeId: number) {
    resetFormData()
    state.title = '编辑'
    state.actionType = 2
    state.dialogVisible = true
    getData(dbTypeId)
  },

})
</script>

<template>
  <el-drawer v-model="state.dialogVisible" :title="state.title" width="600px" :close-on-click-modal="false" append-to-body destroy-on-close>
    <el-form ref="formRef" :model="state.formData" :rules="formRules" label-width="120px" label-suffix="：">
      <el-form-item label="分类名称" prop="dbTypeTitle">
        <el-input v-model="state.formData.dbTypeTitle" placeholder="请输入标题" />
      </el-form-item>

      <el-form-item label="简要说明" prop="dbTypeDesc">
        <el-input v-model="state.formData.dbTypeDesc" type="textarea" rows="10" placeholder="请输入简要说明" />
      </el-form-item>
    </el-form>

    <template #footer>
      <el-button size="large" @click="onCancel">
        取消
      </el-button>
      <el-button type="primary" size="large" @click="onSubmit">
        保存
      </el-button>
    </template>
  </el-drawer>
</template>
